/*  BotikBalance - User's account balance informer for Botik Network 
 *                 for Windows 9x/ME/NT/2000/XP/2003
 *  Copyright (C) 2005 Alexander V. Melnikoff
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public Licensse as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

/* Sorry for the long lines in the sources, I have wide screen... ;-)
 */

#ifndef __MAINWINDOW_H__
#define __MAINWINDOW_H__

class CMainWindow : public CWindow 
{
public:
	CMainWindow(void);
	~CMainWindow(void);

	static BOOL CreateObject();

	BOOL Create(HWND hWndPrn_);
	VOID UpdateGUI(HWND hWnd_);
	BOOL UpdateSettings(VOID);
	VOID StartTrayAnimation();
	VOID StopTrayAnimation();
	VOID StartUpdating();
	VOID ShowCurrentStateIcon();
	VOID SetCurrentState(INT nCurState_);
	BOOL ValidateNewConfiguration();
	BOOL Startup();
	VOID StartAutoUpdate();
	VOID StopAutoUpdate();

	LRESULT OnInitDialog(HWND hWnd_, WPARAM wParam_, LPARAM lParam_);
	LRESULT OnDestroy(HWND hWnd_, WPARAM wParam_, LPARAM lParam_);
	LRESULT OnCommand(HWND hWnd_, WPARAM wParam_, LPARAM lParam_);
	LRESULT OnNotify(HWND hWnd_, WPARAM wParam_, LPARAM lParam_);
	LRESULT OnUserNotifyIcon(HWND hWnd_, WPARAM wParam_, LPARAM lParam_);
	LRESULT OnTimer(HWND hWnd_, WPARAM wParam_, LPARAM lParam_);

	LRESULT WndProc(HWND hWnd_, UINT uMsg_, WPARAM wParam_, LPARAM lParam_);
	static LRESULT _WndProc(HWND hWnd_, UINT uMsg_, WPARAM wParam_, LPARAM lParam_);

	LRESULT WndProcAboutDlg(HWND hDlg_, UINT uMsg_, WPARAM wParam_, LPARAM lParam_);
	static LRESULT _WndProcAboutDlg(HWND hWnd_, UINT uMsg_, WPARAM wParam_, LPARAM lParam_);

	LRESULT WndProcLicenseDlg(HWND hDlg_, UINT uMsg_, WPARAM wParam_, LPARAM lParam_);
	static LRESULT _WndProcLicenseDlg(HWND hWnd_, UINT uMsg_, WPARAM wParam_, LPARAM lParam_);

	UINT UpdateDataThread(void* pPrm_);
	static unsigned int __stdcall _UpdateDataThread(void* pPrm_);

public:
	UINT WM_TASKBARCREATED;

private:
	enum 
	{
		TRAY_ANIMATION_TIMER_ID = 1,
		UPDATE_TIMEOUT_TIMER_ID = 2,
		SHOWINFOWND_DELEY_TIMER_ID = 3		// To prevent popup window on double click
	};

private:
	BOOL			m_fChanged;
	CNotifyIcon*	m_pNIcon;
	HANDLE			m_hEvent;
	BOOL			m_fLoop;
	BOOL			m_fTimerArmed;
	BOOL			m_fShowAlarm;
};

extern CMainWindow* MainWindow;

#endif // __MAINWINDOW_H__