/*  BotikBalance - User's account balance informer for Botik Network 
 *                 for Windows 9x/ME/NT/2000/XP/2003
 *  Copyright (C) 2005 Alexander V. Melnikoff
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public Licensse as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

/* Sorry for the long lines in the sources, I have wide screen... ;-)
 */

#ifndef __NOTIFYWINDOW_H__
#define __NOTIFYWINDOW_H__

#define NW_DISPLAY_TEXT_DATA		1
#define NW_DISPLAY_TABLE_DATA		2

#include <vector>
using namespace std;

class CNotifyWindow : public CWindow
{
public:
	CNotifyWindow(void);
	~CNotifyWindow(void);

	static BOOL CreateObject();

	BOOL  Create(HWND hWndPrn_);
	BOOL  SetWindowPosition();
	VOID  PopUp();
	VOID  Hide();
	VOID  SetText(UINT nFlags_, LPTSTR szText_);
	DWORD AddRow();
	DWORD AddColumn(DWORD dwRow_, UINT nFalgs_, LPTSTR szFormat_, ...);
	VOID  ClearTable();
	VOID  SetDisplayData(UINT nType_);

	LRESULT OnInitDialog(HWND hWnd_, WPARAM wParam_, LPARAM lParam_);
	LRESULT OnPaint(HWND hWnd_, WPARAM wParam_, LPARAM lParam_);
	LRESULT OnDestroy(HWND hWnd_, WPARAM wParam_, LPARAM lParam_);
	LRESULT OnCommand(HWND hWnd_, WPARAM wParam_, LPARAM lParam_);
	LRESULT OnNotify(HWND hWnd_, WPARAM wParam_, LPARAM lParam_);
	LRESULT OnTimer(HWND hWnd_, WPARAM wParam_, LPARAM lParam_);

	LRESULT WndProc(HWND hWnd_, UINT uMsg_, WPARAM wParam_, LPARAM lParam_);
	static LRESULT _WndProc(HWND hWnd_, UINT uMsg_, WPARAM wParam_, LPARAM lParam_);

private:
	VOID DrawFrame(HDC hdc_, CONST LPRECT prc_, COLORREF cr1_, COLORREF cr2_);
	VOID DisplayTableData(HDC hdc_);

private:
	enum {
		NOTIFYWND_TIMER_ID = 1,
	};

	typedef struct tagNFTABLECELL
	{
		tagNFTABLECELL* prev;
		tagNFTABLECELL* next;
		LPTSTR text;
		UINT nFlags;
	} NFTABLECELL, * LPNFTABLECELL;

	typedef vector<int> INTVECTOR;
	typedef vector<int>::iterator INTVECTORITR;
	typedef vector<LPNFTABLECELL> NFTABLE;
	typedef vector<LPNFTABLECELL>::iterator NFTABLEITR;

private:
	BOOL		m_fShow;
	LONG		m_lWndWidth;
	LONG		m_lWndHeight;
	LPTSTR		m_szText;
	UINT		m_nTextFlags;
	NFTABLE		m_nftContent;
	UINT		m_nDisplInfo;
	COLORREF	m_crWndBgColor;
	COLORREF	m_crWndFgColor;
	COLORREF	m_crWndFrmOutlineColor;
	COLORREF	m_crWndFrmNormLColor;
	COLORREF	m_crWndFrmNormDColor;
	COLORREF	m_crWndFrmWarnLColor;
	COLORREF	m_crWndFrmWarnDColor;
	CRITICAL_SECTION m_cs;
};

extern CNotifyWindow* NotifyWindow;

#endif // __NOTIFYWINDOW_H__