/*  BotikBalance - User's account balance informer for Botik Network 
 *                 for Windows 9x/ME/NT/2000/XP/2003
 *  Copyright (C) 2005 Alexander V. Melnikoff
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public Licensse as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

/* Sorry for the long lines in the sources, I have wide screen... ;-)
 */

#include <stdafx.h>
#include <window.h>

CWindow::CWindow()
{
	cfdprintf(_T("CWindow::CWindow"));
	m_hWnd = NULL;
	cfdprintf(_T("!CWindow::CWindow"));
};

CWindow::~CWindow()
{
	cfdprintf(_T("CWindow::~CWindow"));
	cfdprintf(_T("!CWindow::~CWindow"));
};

HWND CWindow::GetHWnd() const
{
	return(m_hWnd);
};

BOOL CWindow::Create(HWND hWndPrn_)
{
	cfdprintf(_T("CWindow::Create"));
	cfdprintf(_T("!CWindow::Create"));

	return(FALSE);
};

BOOL CWindow::Destroy()
{
	cfdprintf(_T("CWindow::Destroy: m_hWnd: %d"), m_hWnd);
	assert(m_hWnd != NULL);
	::DestroyWindow(m_hWnd);
	cfdprintf(_T("!CWindow::Destroy"));

	return(FALSE);
};

VOID CWindow::Show(DWORD dwShow_)
{
	cfdprintf(_T("CWindow::Show"));
	::ShowWindow(m_hWnd, dwShow_);
	cfdprintf(_T("!CWindow::Show"));
};

VOID CWindow::MoveTo(CONST LONG lX_, CONST LONG lY_, BOOL fRepaint_)
{
	cfdprintf(_T("CWindow::MoveTo"));
	cfdprintf(_T("!CWindow::MoveTo"));
};

VOID CWindow::MoveTo(CONST LPRECT pRc_, BOOL fRepaint_)
{
	cfdprintf(_T("CWindow::MoveTo"));
	::MoveWindow(m_hWnd, pRc_->left, pRc_->top, pRc_->right, pRc_->bottom, fRepaint_);
	cfdprintf(_T("!CWindow::MoveTo"));
};

VOID CWindow::MoveTo(CONST LONG lX_, CONST LONG lY_, CONST LONG lW_, CONST LONG lH_, BOOL fRepaint_)
{
	cfdprintf(_T("CWindow::MoveTo"));
	::MoveWindow(m_hWnd, lX_, lY_, lW_, lH_, fRepaint_);
	cfdprintf(_T("!CWindow::MoveTo"));
};

