/*  BotikBalance - User's account balance informer for Botik Network 
 *                 for Windows 9x/ME/NT/2000/XP/2003
 *  Copyright (C) 2005 Alexander V. Melnikoff
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public Licensse as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

/* Sorry for the long lines in the sources, I have wide screen... ;-)
 */

#ifndef __BBOBJ_H__
#define __BBOBJ_H__

#ifdef IBBAR_EXPORTS
  #define BBOBJ_API __declspec(dllexport)
#else
  #define BBOBJ_API __declspec(dllimport)
#endif

// Operation codes
typedef enum {
    BBO_RET_OK                = 0,	// OK status
    BBO_RET_FAIL              = -1,	// Unecspected error occured
	BBO_RET_INETOPEN          = -2,	// Open internet session failed
	BBO_RET_INETCONN          = -3,	// Connect operation failed
	BBO_RET_OPENREQ           = -4,	// Open request operation failed
	BBO_RET_SENDREQ           = -5,	// Send request operation failed
	BBO_RET_INETREAD          = -6,	// Read operation failed
	BBO_RET_WRONGMETHOD       = -7,	// Wrong HTTP method
	BBO_RET_WRONGPROXY        = -8,	// Incorrect proxy address (must be address:port)
	BBO_RET_PARSEFAILED       = -9,	// Parsing data failed
	BBO_RET_LOGIN_BADPSWD     = -10,	// Nadmin login failed, bad password
	BBO_RET_LOGIN_BADUSER     = -11,	// Nadmin login failed, bad user name
	BBO_RET_LOGIN_BADACCOUNT  = -12,	// Nadmin login failed, bad account name
	BBO_RET_LOGIN_NOTLOGGEDIN = -13	// Nadmin login failed
} BBO_ErrorCodes;

// ProgIDs
#define BBOBJ_PROG_ID		_T("Synapsis")
#define BBOBJ_OBJ_NAME		_T("BotikBalance")

#define BBOBJ_OBJ_NAME_CAPT	_T("Botik::Balance Library...")

#endif // __BBOBJ_H__
