/*  BotikBalance - User's account balance informer for Botik Network 
 *                 for Windows 9x/ME/NT/2000/XP/2003
 *  Copyright (C) 2005 Alexander V. Melnikoff
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public Licensse as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

/* Sorry for the long lines in the sources, I have wide screen... ;-)
 */

#ifndef __BOTIKBALANCECOM_H__
#define __BOTIKBALANCECOM_H__

#include <scripthost.h>
#include <botiknadminobj_h.h>

class CBotikBalanceCom :
	public IBotikBalance
{
public:
	CBotikBalanceCom(void);
	~CBotikBalanceCom(void);

public:
	// IUnknown
	virtual HRESULT __stdcall QueryInterface(const IID& riid_, void** ppv_);
	virtual ULONG	__stdcall AddRef(void);
	virtual ULONG	__stdcall Release(void);

	// IDispatch
	virtual HRESULT __stdcall GetTypeInfoCount(UINT* pCountTypeInfo_);
	virtual HRESULT __stdcall GetTypeInfo(UINT iTypeInfo_, LCID, ITypeInfo** ppITypeInfo_);
	virtual HRESULT __stdcall GetIDsOfNames(const IID& riid_, OLECHAR** arrayNames_, UINT cNames_, LCID, DISPID* arrayDispIDs_);
	virtual HRESULT __stdcall Invoke(DISPID dispidMember_, const IID& riid_, LCID, WORD wFlags_, 
									 DISPPARAMS* pDispParams_, VARIANT* pvarRes_, EXCEPINFO* pEI_, UINT* pArgErr_);

	// IBotikBalance
	virtual HRESULT __stdcall UseRegistryIdentity(LONG lPlace_, BOOL* pfRet_);
	virtual HRESULT __stdcall GetData(BSTR bsName_, BSTR* pbsVal_);
	virtual HRESULT __stdcall Connect(LONG* plRet_);
	virtual HRESULT __stdcall Update(LONG* plRet_);
	virtual HRESULT __stdcall Disconnect(LONG* plRet_);
	virtual HRESULT __stdcall GetErrorDescription(LONG lCode_, BSTR* pbsRet_);

	virtual HRESULT __stdcall put_AccountName(BSTR bsVal_);
	virtual HRESULT __stdcall put_User(BSTR bsVal_);
	virtual HRESULT __stdcall put_Password(BSTR bsVal_);
	virtual HRESULT __stdcall put_UseProxy(BOOL  fVal_);
	virtual HRESULT __stdcall get_UseProxy(BOOL* pfVal_);
	virtual HRESULT __stdcall put_ProxyServer(BSTR  bsVal_);
	virtual HRESULT __stdcall get_ProxyServer(BSTR* pbsVal_);

	// CBotikBalanceCom
	BOOL Init(VOID);
	BOOL InitScriptEngine(VOID);
	BOOL RunBotikBalanceObjScript(VOID);
	VOID UnInitScriptEngine();

private:
	LONG		m_cRef;
	ITypeInfo*	m_pITypeInfo;

	CScriptHost*		m_pSH;
	IActiveScript*		m_pIAS;
	IActiveScriptParse*	m_pIASP;
};

#endif // __BOTIKBALANCECOM_H__